import pytest
from . import check


@pytest.hookimpl(hookwrapper=True, trylast=True)
def pytest_runtest_makereport(item, call):
    outcome = yield
    report = outcome.get_result()

    check.merge_failures()
    failures = check.get_all_failures()
    check.clear_all_failures()

    if failures:
        summary = "Failed Checks: {}".format(len(failures))
        longrepr = ["\n".join(failures), "-" * 60, summary]
        if report.longrepr:
            longrepr.append("-" * 60)
            longrepr.append(report.longreprtext)
            report.longrepr = "\n".join(longrepr)
        else:
            report.longrepr = "\n".join(longrepr)
        report.outcome = "failed"
